/*
 * This file is part of W3Olista, the statistics gathering program for
 * the WWW.                  This sourcecode is (c) Frank Pilhofer '95
 *
 * It is  distributed without warranty. The complete license terms for
 * this software  are included in  the file 'License.html'  in the doc
 * subdirectory. If  your copy came  without this file, you should get
 * it on the Web at    http://www.uni-frankfurt.de/~fp/Tools/W3Olista/
 * or contact the author,               fp@informatik.uni-frankfurt.de
 */

/*
 * Domain names as grabbed from
 * http://www.eit.com/cgi-bin/viewsource/software/getstats/domain.codes.txt
 */

#include <stdlib.h>
#include <stdio.h>		/* in case stdlib.h doesn't define NULL */
#include "toolbox.h"

static char *DOunknown = "Unknown Domain";
static char *DOdomains[] = {
   "(num)", "unresolved numerical domain",
   "AD", "Andorra" ,
   "AE", "United Arab Emirates" ,
   "AF", "Afghanistan" ,
   "AG", "Antigua and Barbuda" ,
   "AI", "Anguilla" ,
   "AL", "Albania" ,
   "AM", "Armenia" ,
   "AN", "Netherland Antilles" ,
   "AO", "Angola" ,
   "AQ", "Antarctica" ,
   "AR", "Argentina" ,
   "ARPA", "Old style Arpanet" ,
   "AS", "American Samoa" ,
   "AT", "Austria" ,
   "AU", "Australia" ,
   "AW", "Aruba" ,
   "AZ", "Azerbaidjan" ,
   "BA", "Bosnia-Herzegovina" ,
   "BB", "Barbados" ,
   "BD", "Banglades" ,
   "BE", "Belgium" ,
   "BF", "Burkina Faso" ,
   "BG", "Bulgaria" ,
   "BH", "Bahrain" ,
   "BI", "Burundi" ,
   "BJ", "Benin" ,
   "BM", "Bermuda" ,
   "BN", "Brunei Darussalam" ,
   "BO", "Bolivia" ,
   "BR", "Brazil" ,
   "BS", "Bahamas" ,
   "BT", "Buthan" ,
   "BV", "Bouvet Island" ,
   "BW", "Botswana" ,
   "BY", "Belarus" ,
   "BZ", "Belize" ,
   "CA", "Canada" ,
   "CC", "Cocos (Keeling) Islands" ,
   "CF", "Central African Republic" ,
   "CG", "Congo" ,
   "CH", "Switzerland" ,
   "CI", "Ivory Coast" ,
   "CK", "Cook Islands" ,
   "CL", "Chile" ,
   "CM", "Cameroon" ,
   "CN", "China" ,
   "CO", "Colombia" ,
   "COM", "US Commercial" ,
   "CR", "Costa Rica" ,
   "CS", "Czechoslovakia" ,
   "CU", "Cuba" ,
   "CV", "Cape Verde" ,
   "CX", "Christmas Island" ,
   "CY", "Cyprus" ,
   "CZ", "Czech Republic" ,
   "DE", "Germany" ,
   "DJ", "Djibouti" ,
   "DK", "Denmark" ,
   "DM", "Dominica" ,
   "DO", "Dominican Republic" ,
   "DZ", "Algeria" ,
   "EC", "Ecuador" ,
   "EDU", "US Educational" ,
   "EE", "Estonia" ,
   "EG", "Egypt" ,
   "EH", "Western Sahara" ,
   "ES", "Spain" ,
   "ET", "Ethiopia" ,
   "FI", "Finland" ,
   "FJ", "Fiji" ,
   "FK", "Falkland Islands (Malvinas)" ,
   "FM", "Micronesia" ,
   "FO", "Faroe Islands" ,
   "FR", "France" ,
   "FX", "France (European Territory)" ,
   "GA", "Gabon" ,
   "GB", "Great Britain (UK)" ,
   "GD", "Grenada" ,
   "GE", "Georgia" ,
   "GF", "Guyana (French)" ,
   "GH", "Ghana" ,
   "GI", "Gibraltar" ,
   "GL", "Greenland" ,
   "GM", "Gambia" ,
   "GN", "Guinea" ,
   "GOV", "US Government" ,
   "GP", "Guadeloupe (French)" ,
   "GQ", "Equatorial Guinea" ,
   "GR", "Greece" ,
   "GT", "Guatemala" ,
   "GU", "Guam (US)" ,
   "GW", "Guinea Bissau" ,
   "GY", "Guyana" ,
   "HK", "Hong Kong" ,
   "HM", "Heard and McDonald Islands" ,
   "HN", "Honduras" ,
   "HR", "Croatia" ,
   "HT", "Haiti" ,
   "HU", "Hungary" ,
   "ID", "Indonesia" ,
   "IE", "Ireland" ,
   "IL", "Israel" ,
   "IN", "India" ,
   "INT", "International" ,
   "IO", "British Indian Ocean Territory" ,
   "IQ", "Iraq" ,
   "IR", "Iran" ,
   "IS", "Iceland" ,
   "IT", "Italy" ,
   "JM", "Jamaica" ,
   "JO", "Jordan" ,
   "JP", "Japan" ,
   "KE", "Kenya" ,
   "KG", "Kirgistan" ,
   "KH", "Cambodia" ,
   "KI", "Kiribati" ,
   "KM", "Comoros" ,
   "KN", "Saint Kitts Nevis Anguilla" ,
   "KP", "North Korea" ,
   "KR", "South Korea" ,
   "KW", "Kuwait" ,
   "KY", "Cayman Islands" ,
   "KZ", "Kazachstan" ,
   "LA", "Laos" ,
   "LB", "Lebanon" ,
   "LC", "Saint Lucia" ,
   "LI", "Liechtenstein" ,
   "LK", "Sri Lanka" ,
   "LR", "Liberia" ,
   "LS", "Lesotho" ,
   "LT", "Lithuania" ,
   "LU", "Luxembourg" ,
   "LV", "Latvia" ,
   "LY", "Libya" ,
   "MA", "Morocco" ,
   "MC", "Monaco" ,
   "MD", "Moldavia" ,
   "MG", "Madagascar" ,
   "MH", "Marshall Islands" ,
   "MIL", "US Military" ,
   "ML", "Mali" ,
   "MM", "Myanmar" ,
   "MN", "Mongolia" ,
   "MO", "Macau" ,
   "MP", "Northern Mariana Islands" ,
   "MQ", "Martinique (French)" ,
   "MR", "Mauritania" ,
   "MS", "Montserrat" ,
   "MT", "Malta" ,
   "MU", "Mauritius" ,
   "MV", "Maldives" ,
   "MW", "Malawi" ,
   "MX", "Mexico" ,
   "MY", "Malaysia" ,
   "MZ", "Mozambique" ,
   "NA", "Namibia" ,
   "NATO", "Nato field" ,
   "NC", "New Caledonia (French)" ,
   "NE", "Niger" ,
   "NET", "Network" ,
   "NF", "Norfolk Island" ,
   "NG", "Nigeria" ,
   "NI", "Nicaragua" ,
   "NL", "Netherlands" ,
   "NO", "Norway" ,
   "NP", "Nepal" ,
   "NR", "Nauru" ,
   "NT", "Neutral Zone" ,
   "NU", "Niue" ,
   "NZ", "New Zealand" ,
   "OM", "Oman" ,
   "ORG", "Non-Profit",
   "PA", "Panama" ,
   "PE", "Peru" ,
   "PF", "Polynesia (French)" ,
   "PG", "Papua New" ,
   "PH", "Philippines" ,
   "PK", "Pakistan" ,
   "PL", "Poland" ,
   "PM", "Saint Pierre and Miquelon" ,
   "PN", "Pitcairn" ,
   "PR", "Puerto Rico (US)" ,
   "PT", "Portugal" ,
   "PW", "Palau" ,
   "PY", "Paraguay" ,
   "QA", "Qatar" ,
   "RE", "Reunion (French)" ,
   "RO", "Romania" ,
   "RU", "Russian Federation" ,
   "RW", "Rwanda" ,
   "SA", "Saudi Arabia" ,
   "SB", "Solomon Islands" ,
   "SC", "Seychelles" ,
   "SD", "Sudan" ,
   "SE", "Sweden" ,
   "SG", "Singapore" ,
   "SH", "Saint Helena" ,
   "SI", "Slovenia" ,
   "SJ", "Svalbard and Jan Mayen Islands" ,
   "SK", "Slovak Republic" ,
   "SL", "Sierra Leone" ,
   "SM", "San Marino" ,
   "SN", "Senegal" ,
   "SO", "Somalia" ,
   "SR", "Suriname" ,
   "ST", "Saint Tome and Principe" ,
   "SU", "Soviet Union" ,
   "SV", "El Salvador" ,
   "SY", "Syria" ,
   "SZ", "Swaziland" ,
   "TC", "Turks and Caicos Islands" ,
   "TD", "Chad" ,
   "TF", "French Southern Territory" ,
   "TG", "Togo" ,
   "TH", "Thailand" ,
   "TJ", "Tadjikistan" ,
   "TK", "Tokelau" ,
   "TM", "Turkmenistan" ,
   "TN", "Tunisia" ,
   "TO", "Tonga" ,
   "TP", "East Timor" ,
   "TR", "Turkey" ,
   "TT", "Trinidad and Tobago" ,
   "TV", "Tuvalu" ,
   "TW", "Taiwan" ,
   "TZ", "Tanzania" ,
   "UA", "Ukraine" ,
   "UG", "Uganda" ,
   "UK", "United Kingdom" ,
   "UM", "US Minor Outlying Islands" ,
   "US", "United States" ,
   "UY", "Uruguay" ,
   "UZ", "Uzbekistan" ,
   "VA", "Vatican City State" ,
   "VC", "Saint Vincent and Grenadines" ,
   "VE", "Venezuela" ,
   "VG", "Virgin Islands (British)" ,
   "VI", "Virgin Islands (US)" ,
   "VN", "Vietnam" ,
   "VU", "Vanuatu" ,
   "WF", "Wallis and Futuna Islands" ,
   "WS", "Samoa" ,
   "YE", "Yemen" ,
   "YU", "Yugoslavia" ,
   "ZA", "South Africa" ,
   "ZM", "Zambia" ,
   "ZR", "Zaire" ,
   "ZW", "Zimbabwe" ,
   NULL,  NULL
};

static int DOcomp (const void *el1, const void *el2)
{
  return _FP_stricmp (*((char **)el1),
		      *((char **)el2));
}

char *GetDomainTitle (char *dom)
{
  static int NumDoms=0;
  char **ptr;

  if (NumDoms == 0) {
    ptr = DOdomains;
    while (*ptr) {
      NumDoms++;
      ptr+=2;
    }
  }
  if (NumDoms == 0)
    return DOunknown;

  if ((ptr = (char **) bsearch (&dom, DOdomains, NumDoms, 2*sizeof (char *), DOcomp)) == NULL)
    return DOunknown;

  return *(ptr + 1);
}

