/*
 * This file is part of W3Olista, the statistics gathering program for
 * the WWW.                  This sourcecode is (c) Frank Pilhofer '95
 *
 * It is  distributed without warranty. The complete license terms for
 * this software  are included in  the file 'License.html'  in the doc
 * subdirectory. If  your copy came  without this file, you should get
 * it on the Web at    http://www.uni-frankfurt.de/~fp/Tools/W3Olista/
 * or contact the author,               fp@informatik.uni-frankfurt.de
 */

/*
 * definitions exported from main module to other modules
 */

/*
 * Report types
 */

#define REVERYTHING	0	/* report everything           */
#define RDATES		1	/* selected range of dates     */
#define RTODAY		2	/* only today                  */
#define RYESTERDAY	3	/* yesterday                   */
#define RTHISWEEK	4	/* this week from sun to today */
#define RLASTWEEK	5	/* last week's sun to sat      */
#define RTHISMONTH	6	/* from 1st of month to today  */
#define RLASTMONTH	7	/* last month                  */
#define RLAST24HOURS	8	/* last 24 hours up to now     */
#define RLAST7DAYS	9	/* last 7 days _before_ today  */

/*
 * Types of links that should be printed
 */

#define LNOLINK		0
#define LFILELINK	1
#define LREPLINK	2

/*
 * what to show. can be or'ed. the list values include the sum value
 * since the full listing always also shows the summary
 */
#define HOSTSUM		0x01
#define HOSTLIST	0x03
#define FILESUM		0x04
#define FILELIST	0x0c
#define DATESUM		0x10
#define DATELIST	0x30
#define ENTRYLIST	0x80

/*
 * masks to select the individual detail
 */
#define HOSTDETOFF	0
#define HOSTDETMASK	0x001f
#define FILEDETOFF	5
#define FILEDETMASK	0x03e0
#define DATEDETOFF	10
#define DATEDETMASK	0x7c00

#define HOSTDEPTH(c)	(((c)&HOSTDETMASK)>>HOSTDETOFF)
#define FILEDEPTH(c)	(((c)&FILEDETMASK)>>FILEDETOFF)
#define DATEDEPTH(c)	(((c)&DATEDETMASK)>>DATEDETOFF)

extern char   *version, *patch;
extern char   *servhost, *servtype;
extern int     servport;
extern report *mainreport;
extern int     repwhat;
extern int     maxdepth;
extern int     sort, display;
extern int     linktype;
extern int     resolveaddr;
extern int     cutprefix;
extern int     countunique;
extern struct tm fromdate, todate;
extern char   *repnames[];
extern char   *logdir, *dlogdir;
extern char   *logfile, *dlogfile;
extern int     baroffset, barlength;
