/*
 * This file is not part of W3Olista. It prints out some sample
 * calculations based on our timezone here. It will print invalid
 * results elsewhere. There's really no need to compile and run
 * it.
 */


#include <stdio.h>
#include <time.h>
#include <memory.h>

void main (void)
{
  struct tm a,b,c,d;
  time_t e,f,g,h;

  /*
   * Test series 1
   */
  printf ("Test 1, Mar 28 0200. output should be 0000\n");

  a.tm_mday = 28;
  a.tm_mon  =  2;
  a.tm_year = 95;
  a.tm_hour =  2;
  a.tm_min  =  0;
  a.tm_sec  =  0;

  a.tm_isdst= -1;
  e = mktime (&a);
  
  a.tm_isdst=  0;
  f = mktime (&a);

  a.tm_isdst=  1;
  g = mktime (&a);

  memcpy (&b, localtime (&e), sizeof (struct tm));
  memcpy (&c, gmtime    (&e), sizeof (struct tm));

  printf ("dst=-1: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  e, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  memcpy (&b, localtime (&f), sizeof (struct tm));
  memcpy (&c, gmtime    (&f), sizeof (struct tm));

  printf ("dst= 0: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  f, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  memcpy (&b, localtime (&f), sizeof (struct tm));
  memcpy (&c, gmtime    (&f), sizeof (struct tm));

  printf ("dst= 1: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  g, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  /*
   * Test series 2
   */
  printf ("Test 2, Mar 23 0100. output should be 0000\n");

  a.tm_mday = 23;
  a.tm_mon  =  2;
  a.tm_year = 95;
  a.tm_hour =  1;
  a.tm_min  =  0;
  a.tm_sec  =  0;

  a.tm_isdst= -1;
  e = mktime (&a);
  
  a.tm_isdst=  0;
  f = mktime (&a);

  a.tm_isdst=  1;
  g = mktime (&a);

  memcpy (&b, localtime (&e), sizeof (struct tm));
  memcpy (&c, gmtime    (&e), sizeof (struct tm));

  printf ("dst=-1: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  e, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  memcpy (&b, localtime (&f), sizeof (struct tm));
  memcpy (&c, gmtime    (&f), sizeof (struct tm));

  printf ("dst= 0: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  f, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  memcpy (&b, localtime (&f), sizeof (struct tm));
  memcpy (&c, gmtime    (&f), sizeof (struct tm));

  printf ("dst= 1: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  g, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  /*
   * Test series 3
   */
  printf ("Test 3, Mar 28 17:56:26.\n");

  a.tm_mday = 28;
  a.tm_mon  =  2;
  a.tm_year = 95;
  a.tm_hour = 17;
  a.tm_min  = 56;
  a.tm_sec  = 26;

  a.tm_isdst= -1;
  e = mktime (&a);
  
  memcpy (&b, localtime (&e), sizeof (struct tm));
  memcpy (&c, gmtime    (&e), sizeof (struct tm));

  printf ("dst=-1: %ld  local: %02d:%02d:%02d  gm: %02d:%02d:%02d\n",
	  e, b.tm_hour, b.tm_min, b.tm_sec, c.tm_hour, c.tm_min, c.tm_sec);

  f = time(NULL);
  printf ("difference: %ld - %ld = %ld\n",
	  f, e, f-e);
}
